#ifndef YERBACON_LEX_H
#define YERBACON_LEX_H

#include <memory>
#include <vector>
#include <string>
#include <ostream>

struct tok {
    enum type {
        DEFINE, TAG, NUMBER, PLUS, LPAR, LBRACE, LBRACKET, RPAR, RBRACE, RBRACKET, ALPHACHAR, HYPHEN, LCOMP, RCOMP,
        SQUOTE,
        STRING,
        IDENTIFIER,
        SEPARATOR,
        UNEXPECTED
    };
    type toktype;
    std::string toktext;
    tok(type Type, std::string Text): toktype(Type), toktext(Text) {}
    friend std::ostream& operator<<(std::ostream& output, const tok& it) { return output << it.toktext; }
};
std::vector<tok>& lex(const std::string& in);

#endif //YERBACON_TEST_H